Index: frontends/php/include/blocks.inc.php
===================================================================
--- frontends/php/include/blocks.inc.php	(revision 68390)
+++ frontends/php/include/blocks.inc.php	(working copy)
@@ -275,6 +275,9 @@
 		$table->addRow([_('Required server performance, new values per second'),
 			($status !== false && array_key_exists('vps_total', $status)) ? round($status['vps_total'], 2) : '', ''
 		]);
+		$table->addRow([_('Last update of server configuration cache'),
+			($status !== false && array_key_exists('config_reload', $status)) ? date(TIMESTAMP_FORMAT, $status['config_reload']) : '', ''
+		]);
 	}
 
 	// check requirements
Index: frontends/php/include/classes/server/CZabbixServer.php
===================================================================
--- frontends/php/include/classes/server/CZabbixServer.php	(revision 68390)
+++ frontends/php/include/classes/server/CZabbixServer.php	(working copy)
@@ -224,6 +224,10 @@
 					'proxyid' =>				['type' => API_ID, 'flags' => API_REQUIRED]
 				]],
 				'count' =>					['type' => API_STRING_UTF8, 'flags' => API_REQUIRED]	// API_FLOAT 0-n
+			]],
+			// 'config cache reload' is available only for super-admins
+			'config cache reload' =>	['type' => API_OBJECTS, 'flags' => API_NOT_EMPTY, 'fields' => [
+				'count' =>					['type' => API_INT32, 'flags' => API_REQUIRED, 'in' => '0:'.ZBX_MAX_INT32]
 			]]
 		]];
 
Index: frontends/php/include/func.inc.php
===================================================================
--- frontends/php/include/func.inc.php	(revision 68390)
+++ frontends/php/include/func.inc.php	(working copy)
@@ -2169,6 +2169,15 @@
 		}
 	}
 
+	// configuration cache reload time
+	if (array_key_exists('config cache reload', $server_status)) {
+		$status['config_reload'] = 0;
+
+		foreach ($server_status['config cache reload'] as $stats) {
+			$status['config_reload'] += $stats['count'];
+		}
+	}
+
 	return $status;
 }
 
Index: include/dbcache.h
===================================================================
--- include/dbcache.h	(revision 68390)
+++ include/dbcache.h	(working copy)
@@ -577,7 +577,7 @@
 		zbx_vector_ptr_t *items_active_normal, zbx_vector_ptr_t *items_active_notsupported,
 		zbx_vector_ptr_t *items_disabled, zbx_uint64_t *triggers_enabled_ok,
 		zbx_uint64_t *triggers_enabled_problem, zbx_uint64_t *triggers_disabled,
-		zbx_vector_ptr_t *required_performance);
+		zbx_vector_ptr_t *required_performance, zbx_uint64_t *last_config_cache_reload);
 
 void	DCget_expressions_by_names(zbx_vector_ptr_t *expressions, const char * const *names, int names_num);
 void	DCget_expressions_by_name(zbx_vector_ptr_t *expressions, const char *name);
Index: src/libs/zbxdbcache/dbconfig.c
===================================================================
--- src/libs/zbxdbcache/dbconfig.c	(revision 68390)
+++ src/libs/zbxdbcache/dbconfig.c	(working copy)
@@ -9076,7 +9076,7 @@
 		zbx_vector_ptr_t *items_active_normal, zbx_vector_ptr_t *items_active_notsupported,
 		zbx_vector_ptr_t *items_disabled, zbx_uint64_t *triggers_enabled_ok,
 		zbx_uint64_t *triggers_enabled_problem, zbx_uint64_t *triggers_disabled,
-		zbx_vector_ptr_t *required_performance)
+		zbx_vector_ptr_t *required_performance, zbx_uint64_t *last_config_cache_reload)
 {
 	zbx_hashset_iter_t	iter;
 	const ZBX_DC_PROXY	*dc_proxy;
@@ -9115,6 +9115,8 @@
 		proxy_counter_dbl_push(required_performance, dc_proxy->hostid, dc_proxy->required_performance);
 	}
 
+	*last_config_cache_reload = config->sync_ts;
+
 	UNLOCK_CACHE;
 }
 
Index: src/zabbix_server/trapper/trapper.c
===================================================================
--- src/zabbix_server/trapper/trapper.c	(revision 68390)
+++ src/zabbix_server/trapper/trapper.c	(working copy)
@@ -608,7 +608,7 @@
 
 zbx_entry_info_t	templates, hosts_monitored, hosts_not_monitored, items_active_normal, items_active_notsupported,
 			items_disabled, triggers_enabled_ok, triggers_enabled_problem, triggers_disabled, users_online,
-			users_offline, required_performance;
+			users_offline, required_performance, config_cache_reload;
 int			templates_res, users_res;
 
 static void	zbx_status_counters_init(void)
@@ -755,6 +755,16 @@
 			{NULL}
 		}
 	},
+	{"config cache reload",		ZBX_SECTION_ENTRY_THE_ONLY,	USER_TYPE_SUPER_ADMIN,	NULL,
+		{
+			{&config_cache_reload,		ZBX_COUNTER_TYPE_UI64,
+				{
+					{NULL}
+				}
+			},
+			{NULL}
+		}
+	},
 	{NULL}
 };
 
@@ -812,7 +822,8 @@
 	DCget_status(&hosts_monitored.counters, &hosts_not_monitored.counters, &items_active_normal.counters,
 			&items_active_notsupported.counters, &items_disabled.counters,
 			&triggers_enabled_ok.counter.ui64, &triggers_enabled_problem.counter.ui64,
-			&triggers_disabled.counter.ui64, &required_performance.counters);
+			&triggers_disabled.counter.ui64, &required_performance.counters,
+			&config_cache_reload.counter.ui64);
 
 	/* add status information to JSON */
 	for (section = status_sections; NULL != section->name; section++)