diff -Naur zabbix/chart2.php zabbix_legend/chart2.php
--- zabbix/chart2.php	2017-09-25 19:17:36.000000000 +0500
+++ zabbix_legend/chart2.php	2017-11-07 10:23:32.868482185 +0500
@@ -38,6 +38,7 @@
 	'updateProfile' =>	[T_ZBX_STR, O_OPT, null,	null,		null],
 	'width' =>			[T_ZBX_INT, O_OPT, null,	BETWEEN(CLineGraphDraw::GRAPH_WIDTH_MIN, 65535),	null],
 	'height' =>			[T_ZBX_INT, O_OPT, null,	BETWEEN(CLineGraphDraw::GRAPH_HEIGHT_MIN, 65535),	null],
+	'legend' =>			[T_ZBX_INT, O_OPT, null,	IN('0,1'),	null],
 	'outer' =>			[T_ZBX_INT, O_OPT, null,	IN('0,1'),	null],
 	'onlyHeight' =>		[T_ZBX_INT, O_OPT, null,	IN('0,1'),	null]
 ];
@@ -130,7 +131,12 @@
 	$height = $dbGraph['height'];
 }
 
-$graph->showLegend($dbGraph['show_legend']);
+$legend = getRequest('legend');
+if (is_null($legend)) {
+	$legend = $dbGraph['show_legend'];
+}
+$graph->showLegend($legend);
+
 $graph->showWorkPeriod($dbGraph['show_work_period']);
 $graph->showTriggers($dbGraph['show_triggers']);
 $graph->setWidth($width);
diff -Naur zabbix/include/classes/screens/CScreenGraph.php zabbix_legend/include/classes/screens/CScreenGraph.php
--- zabbix/include/classes/screens/CScreenGraph.php	2017-09-25 19:17:35.000000000 +0500
+++ zabbix_legend/include/classes/screens/CScreenGraph.php	2017-11-07 10:24:26.981441147 +0500
@@ -40,6 +40,10 @@
 		$legend = $graph['show_legend'];
 		$graph3d = $graph['show_3d'];
 
+		if ($this->screenitem['style'] == 1) {
+			$legend = 0;
+		}
+
 		if ($this->screenitem['dynamic'] == SCREEN_DYNAMIC_ITEM && $this->hostid) {
 			// get host
 			$hosts = API::Host()->get([
diff -Naur zabbix/include/classes/widgets/CGraphWidgetForm.php zabbix_legend/include/classes/widgets/CGraphWidgetForm.php
--- zabbix/include/classes/widgets/CGraphWidgetForm.php	2017-09-25 19:17:35.000000000 +0500
+++ zabbix_legend/include/classes/widgets/CGraphWidgetForm.php	2017-11-07 10:25:06.994934294 +0500
@@ -64,6 +64,15 @@
 			$this->fields[] = $field_graph;
 		}
 
+		// Do not show legend.
+		$field_dont_show_legend = (new CWidgetFieldCheckBox('style', _('Do not show legend')))->setDefault(0);
+
+		if (array_key_exists('style', $this->data)) {
+			$field_dont_show_legend->setValue($this->data['style']);
+		}
+
+		$this->fields[] = $field_disable_legend;
+
 		// dynamic item
 		$field_dynamic = (new CWidgetFieldCheckBox('dynamic', _('Dynamic item')))->setDefault(WIDGET_SIMPLE_ITEM);
 
diff -Naur zabbix/include/views/monitoring.screen.constructor.edit.php zabbix_legend/include/views/monitoring.screen.constructor.edit.php
--- zabbix/include/views/monitoring.screen.constructor.edit.php	2017-09-25 19:17:35.000000000 +0500
+++ zabbix_legend/include/views/monitoring.screen.constructor.edit.php	2017-11-07 10:27:03.170569992 +0500
@@ -138,6 +138,7 @@
 		(new CDiv())->addClass(ZBX_STYLE_FORM_INPUT_MARGIN),
 		$selectButton
 	]);
+	$screenFormList->addRow(_('Do not show legend'), (new CCheckBox('style'))->setChecked($style == 1));
 }
 
 /*
@@ -190,6 +191,7 @@
 		(new CNumericBox('max_columns', $maxColumns, 3, false, false, false))
 			->setWidth(ZBX_TEXTAREA_NUMERIC_STANDARD_WIDTH)
 	);
+	$screenFormList->addRow(_('Do not show legend'), (new CCheckBox('style'))->setChecked($style == 1));
 }
 
 /*
@@ -237,6 +239,7 @@
 		(new CDiv())->addClass(ZBX_STYLE_FORM_INPUT_MARGIN),
 		$selectButton
 	]);
+	$screenFormList->addRow(_('Do not show legend'), (new CCheckBox('style'))->setChecked($style == 1));
 }
 
 /*
@@ -289,6 +292,7 @@
 		(new CNumericBox('max_columns', $maxColumns, 3, false, false, false))
 			->setWidth(ZBX_TEXTAREA_NUMERIC_STANDARD_WIDTH)
 	);
+	$screenFormList->addRow(_('Do not show legend'), (new CCheckBox('style'))->setChecked($style == 1));
 }
 
 /*
diff -Naur zabbix/locale/en_US/LC_MESSAGES/frontend.po zabbix_legend/locale/en_US/LC_MESSAGES/frontend.po
--- zabbix/locale/en_US/LC_MESSAGES/frontend.po	2017-09-25 19:17:37.000000000 +0500
+++ zabbix_legend/locale/en_US/LC_MESSAGES/frontend.po	2017-11-07 10:28:39.423965219 +0500
@@ -5003,6 +5003,15 @@
 msgid "Do not calculate"
 msgstr "Do not calculate"
 
+#: include/classes/widgets/CGraphWidgetForm.php:67
+#: include/classes/widgets/CGraphWidgetForm.php:68
+#: include/views/monitoring.screen.constructor.edit.php:141
+#: include/views/monitoring.screen.constructor.edit.php:194
+#: include/views/monitoring.screen.constructor.edit.php:242
+#: include/views/monitoring.screen.constructor.edit.php:295
+msgid "Do not show legend"
+msgstr "Do not show legend"
+
 #: jsLoader.php:212
 msgid "Do you wish to replace the conditional expression?"
 msgstr "Do you wish to replace the conditional expression?"
diff -Naur zabbix/locale/ru/LC_MESSAGES/frontend.po zabbix_legend/locale/ru/LC_MESSAGES/frontend.po
--- zabbix/locale/ru/LC_MESSAGES/frontend.po	2017-09-25 19:17:37.000000000 +0500
+++ zabbix_legend/locale/ru/LC_MESSAGES/frontend.po	2017-11-07 10:29:23.550315746 +0500
@@ -5063,6 +5063,15 @@
 msgid "Do not calculate"
 msgstr "Без вычисления"
 
+#: include/classes/widgets/CGraphWidgetForm.php:67
+#: include/classes/widgets/CGraphWidgetForm.php:68
+#: include/views/monitoring.screen.constructor.edit.php:141
+#: include/views/monitoring.screen.constructor.edit.php:194
+#: include/views/monitoring.screen.constructor.edit.php:242
+#: include/views/monitoring.screen.constructor.edit.php:295
+msgid "Do not show legend"
+msgstr "Не отображать легенду"
+
 #: jsLoader.php:212
 msgid "Do you wish to replace the conditional expression?"
 msgstr "Вы хотите заменить условие выражения?"